<?php
	// Exit if accessed directly
	if( !defined( 'ABSPATH' ) ) exit;
	
	function mg2wpforo_init(){
		if( function_exists('WPF') ){
			if( wpforo_is_admin() ) $GLOBALS['mg2wpforo'] = WPF_GO2();
		}else{
			add_action( 'admin_notices', 'mg2wpforo_admin_notice__error' );
		}
	}
	add_action('plugins_loaded', 'mg2wpforo_init');
	
	register_activation_hook(MG2WPFORO_BASENAME, 'do_mg2wpforo_activation');
	function do_mg2wpforo_activation($network_wide){
		if ( is_multisite() && $network_wide ) { 
	        global $wpdb;
			
	        $old_blogid = $wpdb->blogid;
	        $blogids = $wpdb->get_col("SELECT `blog_id` FROM {$wpdb->blogs}");
	        foreach ($blogids as $blogid){
	            switch_to_blog($blogid);
	            mg2wpforo_activation();
	        }
	        switch_to_blog($old_blogid);
	    }else{
	        mg2wpforo_activation();
	    }
	}
	
	function mg2wpforo_activation(){
		global $wpdb;
		$sql = "CREATE TABLE IF NOT EXISTS " . $wpdb->prefix . "mg2wpforo(
			id SERIAL PRIMARY KEY,
			obj VARCHAR(20) NOT NULL,
			old_id BIGINT UNSIGNED NOT NULL,
			new_id BIGINT UNSIGNED NOT NULL,
			UNIQUE KEY unqdata(obj,old_id),
			KEY(obj,old_id,new_id)
		)ENGINE = MyISAM";
		$wpdb->query($sql);
		$sql = "TRUNCATE ".$wpdb->prefix."mg2wpforo";
		$wpdb->query($sql);
		/*$sql = "ALTER TABLE " . $wpdb->prefix . "wpforo_topics ENGINE = MyISAM";
		$wpdb->query($sql);
		$sql = "ALTER TABLE " . $wpdb->prefix . "wpforo_posts ENGINE = MyISAM";
		$wpdb->query($sql);*/

        $upload_dir = wp_upload_dir();
        $avatar_basedir = go2wpf_fix_directory( $upload_dir['basedir'] . "/wpforo/avatars" );
        $attach_basedir = go2wpf_fix_directory( $upload_dir['basedir'] . "/wpforo/attachments" );

        if( !is_dir($avatar_basedir) ) wp_mkdir_p($avatar_basedir);
        if( !is_dir($attach_basedir) ) wp_mkdir_p($attach_basedir);
	}
	
	function mg2wpforo_admin_notice__error() {
		$class = 'notice notice-error';
		$message = __( 'Migrate2wpForo Notice: Please activate required <a href="http://wpforo.com">wpForo plugin</a> otherwise <b>Migrate2wpForo</b> will not work', 'mg2wpforo' );
		printf( '<div class="%1$s"><p>%2$s</p></div>', $class, $message ); 
	}
	
	function mg2wpforo_admin_notice__finish(){
		$class = 'notice';
		$message = '';
		if($_GET['mg2wpforo'] == 'finish'){
			$class = 'notice notice-success ';
			$message = __( 'Migrate2wpForo Notice: Successfully Finished', 'mg2wpforo' );
		}
		printf( '<div class="%1$s"><p>%2$s</p></div>', $class, $message ); 
	}
	
	function mg2wpforo_admin_notice__no_forum_found(){
		$class = 'notice notice-warning ';
		$message = __( 'Migrate2wpForo Notice: We can\'t find this board on this system', 'mg2wpforo' );
		printf( '<div class="%1$s"><p>%2$s</p></div>', $class, $message );
	}

    /**
     * @param string $dir
     * @return string
     */
	function go2wpf_fix_directory($dir){
	    $dir = str_replace( array('/', '\\', '\\\\'), DIRECTORY_SEPARATOR, $dir );
	    $dir = rtrim( trim($dir), DIRECTORY_SEPARATOR );
	    return  $dir;
    }

    /**
     * @param array $array
     * @return bool
     */
    function go2wpf_array_values_is_all_true($array){
	    foreach ($array as $a) if(!$a) return false;
	    return true;
    }

    /**
    * @param string $str
    * @return int
    */
	function go2wpf_str_to_int_id($str){
        $id = 0;
        if( is_string($str) || is_numeric($str) ) foreach(str_split( md5($str) ) as $letter) $id += ord($letter);
        return $id;
    }

    /**
     * @param array $match
     * @return string
     */
    function go2wpf_style_bb2html($match){
        $style = trim( str_replace( array(' ', '=', "'", '"', 'size:'), array('; ', ':', '', '', 'font-size:'), trim($match[1]) ) );
        $html = '<span style="'.$style.'">';
        return $html;
    }

    /**
     * @param string $text
     * @return string
     */
    function go2wpf_bb2html($text){
        $patterns = array(
            '#(src|href)=([^\"\'\]<>\s]+)#isu',
            '#\[(/?)quote[^\[\]]*?\]#isu',
            '#\[img[^\[\]]*?\][\r\n\t\s\0]*([^\[\]]*?)[\r\n\t\s\0]*\[/img\]#isu',
            '#\[url[\r\n\t\s\0]*?=[\r\n\t\s\0\'\"]*?([^\[\]\r\n\t\s\0\'\"]+?)[\r\n\t\s\0\'\"]*?\](.*?)\[/url\]#isu',
            '#\[url[^\[\]]*?\][\r\n\t\s\0]*([^\r\n\t\s\0]*?)[\r\n\t\s\0]*\[/url\]#isu',
            '#\[(/?)(u|center|marquee|table|tr|td|th|tt|sup|sub|s|ul|ol|li)(?:[\r\n\t\s\0=\'"]+[^\[\]]*|)\]#isu',
            '#\[(/?)(br|p|div)(?:[\r\n\t\s\0]+[^\[\]]*|)\]#isu',
            '#\[(/?)(?:big|b|strong|h1|h2|h3|h4|h5|h6)(?:[\r\n\t\s\0]+[^\[\]]*|)\]#isu',
            '#\[(/?)(?:i|em)(?:[\r\n\t\s\0]+[^\[\]]*|)\]#isu',
            '#\[(/?)(?:code|php)(?:[\r\n\t\s\0]+[^\[\]]*|)\]#isu',
            '#\[(/?)strike(?:[\r\n\t\s\0]+[^\[\]]*|)\]#isu',
            '#\[(/?)list(?:[\r\n\t\s\0]+[^\[\]]*|)\]#isu',
            '#\[\*\](.*?)(?:\[/\*\]|$)#ium',
            '#\[hr(?:[\r\n\t\s\0]+[^\[\]]*|)\]#isu',
            '#\[size[^\[\]]*?([\d\w-]+)[^\[\]]*?\]#isu',
            '#\[font=([^\[\]]*?)\]#isu',
            '#\[color[\r\n\t\s\0]*=[\r\n\t\s\0]*(\#?\w+?)[\r\n\t\s\0]*\]#isu',
            '#\[/(?:size|color|style|font)\]#isu',
            '#\[(?:align[\r\n\s\t\0]*=[\r\n\s\t\0]*)?(left|right|center)[^\[\]]*?\]#isu',
            '#\[/(?:left|right|align)\]#isu',
            '#\[youtube[^\[\]]*?\][\r\n\t\s\0]*(https?://[^\[\]]+)[\r\n\t\s\0]*\[/youtube\]#isu',
            '#\[youtube[^\[\]]*?\][\r\n\t\s\0]*([^\[\]]+)[\r\n\t\s\0]*\[/youtube\]#isu',
            '#\[email=[\r\n\t\s\0\'\"]*?([^\r\n\t\s\0\'\"\[\]]+?)[\r\n\t\s\0\'\"]*?\]([^\[\]]*)\[/email\]#isu',
            '#\[email[^\[\]]*?\]([^\[\]]*)\[/email\]#isu',
        );
        $replacements = array(
            '$1="$2"',
            '<$1blockquote>',
            '<img class="go2wpf-bbcode" src="$1">',
            '<a class="go2wpf-bbcode" rel="nofollow" target="_blank" href="$1">$2</a>',
            '<a class="go2wpf-bbcode" rel="nofollow" target="_blank" href="$1">$1</a>',
            '<$1$2>',
            "<br>",
            '<$1b>',
            '<$1i>',
            '<$1pre>',
            '<$1s>',
            '<$1ul>',
            '<li>$1</li>',
            "\n<hr>",
            '<span style="font-size:$1px;">',
            '<span style="font-family:$1;">',
            '<span style="color:$1;">',
            '</span>',
            '<p style="text-align:$1;">',
            '</p>',
            ' $1 ',
            ' https://www.youtube.com/watch?v=$1 ',
            '<a href="mailto: $1">$2</a>',
            '<a href="mailto: $1">$1</a>',
        );
        $text = preg_replace($patterns, $replacements, $text);
        $text = preg_replace_callback('#\[style[\r\n\t\s\0]+([^\[\]]+?)\]#isu', 'go2wpf_style_bb2html', $text);
        $text = preg_replace('#[\r\n\t]*<br[^<>]*?>[\r\n\t]*#isu', '<br>', $text);

        return $text;
    }

    /**
     * @param string $fileurl
     * @param string $filename
     * @param string $mime
     * @return string
     */
    function go2wpf_attach_make_html($fileurl, $filename = '', $mime = ''){
        if (!$filename) $filename = basename($fileurl);
        if (!$mime){
            $filetype = wp_check_filetype( $fileurl );
            $mime = $filetype['type'];
        }
        if(strpos($mime, 'image/') !== FALSE){
            $format = '<div class="wpforo-attached-file-img"><img class="go2wpf-inline-attach-img" style="max-width: 320px; max-height: 240px" src="%s"></div>';
            $filename = sprintf($format, $fileurl);
        }
        $format = '<div class="wpforo-attached-file"><a class="wpforo-default-attachment go2wpf-inline-attach" href="%s"><i class="fas fa-paperclip"></i> %s</a></div>';
        $html = sprintf($format, $fileurl, $filename);

        return $html;
    }